<?php
	// - Configuracion de la Zona Horaria Local
	ini_set('date.timezone', 'America/Monterrey');

	require($_root . 'framework/constants.php');
	
	if (file_exists(FS_CONFIG . 'constantes.php')) {
		require(FS_CONFIG . 'constantes.php');
	}
	
	require($_root . 'framework/variables.php');
	
	require($_root . 'framework/functions.php');

	cleanupSessions();
	initSession();
	
	//-- variables de la aplicación
	if (file_exists(FS_CONFIG . 'variables.php')) {
		require(FS_CONFIG . 'variables.php');
	}

	header("Content-type:text/html; charset=iso-8859-1");

	//-- Limpia cache
	header("Expires: Thu, 27 Mar 1980 23:59:00 GMT");
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	header("Cache-Control: no-cache, must-revalidate");
	header("Pragma: no-cache");

	//-- Verificacion de autenticidad de sesion
	if (sessionHash($_SESSION['user']) != $_SESSION['checksum']) {
		if (preg_match('/.*\/src\/index.php/', $_SERVER['SCRIPT_NAME']) == 0) {
			$params = encodeQueryString(array('do' => 'logout'));
			echo "<script type=\"text/javascript\">alert('Ingreso no autorizado! \\n\\n" . $_SERVER['SCRIPT_NAME'] . "');window.location='"
				. WS_ROOT . $params . "';</script>";
			exit;
		}
	}

	//-- Creacion de objetos publicos para conexion y para manejo de templates
	require(FS_FRAMEWORK . 'classes/pdo.mysql.class.php');
//	$oDB = new DBConnector();

	require(FS_FRAMEWORK . 'classes/template.class.php');
	$oTpl = new Template();

	//-- Objeto usuario de la sesion
	require(FS_CLASSES . 'perfiles.class.php');
	$oUser = $_SESSION['user'];

	//-- Objeto para manejo de permisos del usuario
	$oPerfil = new Perfiles();
	$oPerfil->permisosUsuario($oUser->id_user);

	//-- Decodificacion de linea de parametros de la URL
	$oGET = decodeQueryString($_GET['qs']);
?>
