/*===================================================================================================*/
/*   Helper de JavaScript para apoyar la construccion y control de algunos elementos del template.   */
/*===================================================================================================*/
var dhxWins,swfu;
var SWFUPLOAD_fileTypes = '*.doc;*.docx;*.xls;*.xlsx;*.ppt;*.pptx;*.gif;*.png;*.jpg;*.pdf;';
var SWFUPLOAD_fileTypesDescription = 'Word, Excel, PowerPoint, PDF, Imagenes';
var SWFUPLOAD_fileSizeLimit = '5MB';

$(document).ready(
	function () {
		//-- Agregar PlugIn para activar/desactivar botones con JQuery
		(function($){
			$.fn.setEnabled = function(enable) {
				if (enable) {
					ret = this.filter('button.ui-button')
//						.removeAttr('disabled')
//						.removeClass('disabled');
						.button('enable');
				} else {
					ret = this.filter('button.ui-button')
//						.attr('disabled', 'disabled')
//						.addClass('disabled');
						.button('disable');
				}

				return ret;
			}
		})(jQuery);
		
		//esta funcion alterna con su parametro algun input para hacerlo solo de lectura(false) o de escritura(true).
		(function($){
			$.fn.setInputWrite = function(enable) {
				if (enable) {
					ret = this.filter('input')
						.removeAttr('readonly')
						.removeClass('disabled');
				} else {
					ret = this.filter('input')
						.attr('readonly', 'true')
						.addClass('disabled')
						.val('');
				}

				return ret;
			}
		})(jQuery);
		
		initCssButtons();
		initInactiveControls();

		$('#enlace').click(
			function () {
				var _url = $(this).attr('_url');
				window.location = _url;
			}
		)

		//-- Checa si esta cargada libreria DHTMLX para manejo de ventanas.
		if (typeof dhtmlXWindows != 'undefined') {
			dhxWins = new dhtmlXWindows();
			dhxWins.setSkin("dhx_blue");
		}

		//-- Inicializa llamadas de AJAX de JQuery retorna contenido en Latin-1
		$.ajax({
	        contentType: "application/x-www-form-urlencoded; charset=iso-8859-1"
		});

		$(document).ajaxStart(
			function () {
				BlockUI(true);
			}
		);

		$(document).ajaxStop(
			function () {
				BlockUI();
			}
		);

		$('.custom_date_filter').live('focus',
			function() {
				calendario(this.id);
			}
		);
			
		$('form.no-submit').live('submit',
			function() {
				return false;
			}
		);
	}
);

/**
 * Inicializa el estilo para los input que contengan el atributo readonly
 * añadiendo un estilo para distinguirlos.
 */
function initInactiveControls()
{
	$('div.campo > input[readonly]').addClass('inactive');
}
/**
 * Inicializa el estilo de los elementos tipo "button".
 */
function initCssButtons()
{
	$('.ui-button').button();
	
//	//-- Span wrapper para armado de botones y eventos para "hover" y "focus"
//	$('.cssButton:not(.btnInit)').wrapInner('<span />').addClass('btnInit normal')
//		.mouseover(
//			function () {
//				$(this).addClass('hover');
//			}
//		)
//		.mouseout(
//			function () {
//				if ($(this))
//				$(this).removeClass('hover');
//			}
//		);
//
//	//-- Activar clases para visualizar botones deshabilitados inicialmente en el módulo
//	$('.cssButton:disabled').addClass('disabled');
}

$.postify = function(value) {
	var result = {};

	var buildResult = function(object, prefix) {
		for (var key in object) {

			var postKey = isFinite(key)
				? (prefix != "" ? prefix : "") + "[" + key + "]"
				: (prefix != "" ? prefix + "[" + key + "]" : key);

			switch (typeof (object[key])) {
				case "number": case "string": case "boolean":
					result[postKey] = object[key];
					break;

				case "object":
					if (object[key].toUTCString)
						result[postKey] = object[key].toUTCString().replace("UTC", "GMT");
					else {
						buildResult(object[key], postKey != "" ? postKey : key);
					}
			}
		}
	};

	buildResult(value, "");

	return result;
};

function addDHXWindow(name, x, y, w, h, title, content)
{
	w = dhxWins.createWindow(name, x, y, w, h);
	w.denyResize();
	w.setText(title);
	w.button("park").hide();
	w.button("minmax1").hide();
	w.setModal(true);
	w.bypassConfirm = false;

	$('div.dhtmlx_window_active div.dhtmlx_wins_body_inner div[ida=dhxMainCont]').html(content);

//	w.attachEvent('onMoveFinish', function () {alert('Position : ' + this.getPosition())});
	w.attachEvent('onClose',
		function () {
			if (this.bypassConfirm || confirm('PRECAUCION: Los cambios que no haya guardado se perderán.\n\n'
				+ 'Desea cerrar la ventana actual?')){
					if(swfu != undefined){
						swfu.destroy();
					}
					return true;
			}
			return false;
		}
	);
	
	return w;
}

/**
 * Funcion para generar bloques dinamicos dentro del template
 * @params parent_id : Id del contenedor donde se cargaran los elementos generados.
 * @aescalante
 */
function addDynamicBlock( parent_id )
{
	var contenedor = $('#' + parent_id);
	var max_blocks = parseInt(contenedor.attr('_limit'),10);
	var max_indicated = parseInt($(contenedor.attr('_for')).val(),10);

	if(contenedor.attr('_for') != undefined && (!max_indicated || max_indicated < max_blocks)){
		max_blocks = max_indicated;
	}

	var unlimited = ( max_blocks == undefined ) ? true : false;
	var num = parseInt(contenedor.children().length,10);

	if ( unlimited || num <= max_blocks) {
		contenedor.children(':first').clone(true).appendTo(contenedor).show();
		enumDynamicBlock(contenedor);
	}

	if( num == max_blocks ){
		contenedor.parent().find('button').hide();
	}
}

/**
 * Funcion para enumerar los bloques dinamicos dentro del template
 * @params obj : Objeto (Contenedor de los elementos dinamicos).
 * @aescalante
 */
function enumDynamicBlock(container){
	var num = 0;
	$(container).find('.child').each(function(){
		$(this).find('input,select,textarea').each(function(){
			var name = $(this).attr('name');
			name = name.replace(/(\w+(?:\[\w+\])*\[)\d+(\](?:\[\w+\])*)/, '$1' + num + '$2');
			$(this).attr('name',name);
		});
		num++;
	});
}

/**
 * Funcion para eliminar bloques dinamicos dentro del template
 * @params obj : Objeto this (Elemento que dispara el evento).
 * @aescalante
 */
function deleteDynamicBlock( obj )
{
	var item = $(obj).parent();
	var container = item.parent();
	item.remove();
	container.parent().find('button').show();
	enumDynamicBlock(container);
}

/**
 * Funcion para activar el manejo de los bloques dinamicos dentro del template
 * @calmaguer
 */
function enableDynamicBlocks()
{
	//-- Habilita controles para agregar bloque
	$('.btnAddBlock').click(
		function() {
			addDynamicBlock($(this).attr('_container'));
		}
	);

	//-- Habilita controles para eliminar bloque
	$('.btnDeleteBlock').live(
		'click',
		function() {
			deleteDynamicBlock(this)
		}
	);

	//-- Enumerar los bloques y ocultar el bloque "template"
	$('.btnAddBlock').each(
		function() {
			var item = '#' + $(this).attr('_container')
			$(item).children(':first').hide();
			enumDynamicBlock(item);
		}
	);

	//-- Ocultar los bloques "template"
//	$('#' + $('.btnAddBlock').attr('_container')).children(':first').hide();
}

/**
 * Elimina los acentos y los reemplaza por el caracter normal
 * @author calmaguer
 * @param str String Texto a modificar
 * @return String
 */
function quitarAcentos(str){
	str = str.replace(/á/, 'a').replace(/é/, 'e').replace(/í/, 'i').replace(/ó/, 'o').replace(/ú|ü/, 'u');
	return (str);
}

function quitarCaracteresInvalidos(str){
	str = str.replace(/\W/g, '_');
	return (str);
}

function BlockUI (state)
{
	if (state) {
		var html = '';
		html = '<div class="block-ui"><div id="crystal">&nbsp;</div><div id="message">Espere por favor ...</div></div>';

		$('body').append(html);
	} else {
		$('.block-ui').remove();
	}
}

///**
// * Funcion para enumerar los elementos de la forma dentro del bloque dinamico
// * @calmaguer
// */
//function enumBlocks(item)
//{
//	var num = 0;
//	$(item).children('.child').each(
//		function() {
//			var contenido = $(this).html();
//			var rand = Math.floor(Math.random() * 10000);
//			var append = contenido.replace(/(name=[\'\"]\w+(?:\[\w+\])*\[)\d+(\][^\"|\']*\"|\')/g, '$1' + rand + '$2');
//			$(this).html(append);
//		}
//	);
//}

/*******************************************************************************
 *bloque de funciones para incrementar o decrementar dias a una fecha
 *@cavalos
 *la funcion que debemos ejecutar en nuestros eventos es:
 *recalcFechas(fecInicio,increm)
 *donde.
 *fecInicio = fecha a la que se quiere incrementar /decrementar dias.
 *increm = valor numerico a incremetar o decrementar
 *(para decrementar indicar signo (-)negativo antes del valor)
*******************************************************************************/
var aFinMes = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

  function finMes(nMes, nAno){
   return aFinMes[nMes - 1] + (((nMes == 2) && (nAno % 4) == 0)? 1: 0);
  }

   function padNmb(nStr, nLen, sChr){
    var sRes = String(nStr);
    for (var i = 0; i < nLen - String(nStr).length; i++)
     sRes = sChr + sRes;
    return sRes;
   }

   function makeDateFormat(nDay, nMonth, nYear){
    var sRes;
    sRes = padNmb(nDay, 2, "0") + "/" + padNmb(nMonth, 2, "0") + "/" + padNmb(nYear, 4, "0");
    return sRes;
   }

  function incDate(sFec0){
   var nDia = parseInt(sFec0.substr(0, 2), 10);
   var nMes = parseInt(sFec0.substr(3, 2), 10);
   var nAno = parseInt(sFec0.substr(6, 4), 10);
   nDia += 1;
   if (nDia > finMes(nMes, nAno)){
    nDia = 1;
    nMes += 1;
    if (nMes == 13){
     nMes = 1;
     nAno += 1;
    }
   }
   return makeDateFormat(nDia, nMes, nAno);
  }

  function decDate(sFec0){
   var nDia = Number(sFec0.substr(0, 2));
   var nMes = Number(sFec0.substr(3, 2));
   var nAno = Number(sFec0.substr(6, 4));
   nDia -= 1;
   if (nDia == 0){
    nMes -= 1;
    if (nMes == 0){
     nMes = 12;
     nAno -= 1;
    }
    nDia = finMes(nMes, nAno);
   }
   return makeDateFormat(nDia, nMes, nAno);
  }

  function addToDate(sFec0, sInc){
   var nInc = Math.abs(parseInt(sInc));
   var sRes = sFec0;
   if (parseInt(sInc) >= 0)
    for (var i = 0; i < nInc; i++) sRes = incDate(sRes);
   else
    for (var i = 0; i < nInc; i++) sRes = decDate(sRes);
   return sRes;
  }

  function recalcFechas(fecInicio,increm){
   var  fec = addToDate(fecInicio, increm);
   return  fec;
  }

function calendario(idelem){

	$( "#" + idelem).datepicker({
		changeMonth: true,
		changeYear: true,
		dateFormat: 'dd/mm/yy',
		yearRange: '-80:+15'
	});
}

function removeOptions(oSource)
{
	if (oSource instanceof jQuery) oSource = oSource.get(0)

	for (_k = oSource.length - 1; _k >= 0; _k--) {
		oSource.remove(_k);
	}
}

function roundNumber(num, dec) {
	var result = Math.round(num*Math.pow(10,dec))/Math.pow(10,dec);
	return result;
}