<?php
define('CR', chr(13));
define('LF', chr(10));
define('BEGIN_CERTIFICATE', '-----BEGIN CERTIFICATE-----' . LF);
define('END_CERTIFICATE', '-----END CERTIFICATE-----' . LF);


function base64ToPEM($cert)
{
	$_pem = chunk_split($cert, 64, LF);
	$_pem = BEGIN_CERTIFICATE . $_pem . END_CERTIFICATE;
	return $_pem;
} // base64ToPEM


function DER2PEM($cert)
{
	$_pem = chunk_split(base64_encode($cert), 64, LF);
	$_pem = BEGIN_CERTIFICATE . $_pem . END_CERTIFICATE;
	return $_pem;
}


function baseConversion($numstring, $frombase, $tobase)
{
	$chars = "0123456789abcdefghijklmnopqrstuvwxyz";
	$tostring = substr($chars, 0, $tobase);

	$length = strlen($numstring);
	$result = '';

	for ($i = 0; $i < $length; $i++) {
		$number[$i] = strpos($chars, $numstring{$i});
	}

	do {
		$divide = 0;
		$newlen = 0;

		for ($i = 0; $i < $length; $i++) {
			$divide = $divide * $frombase + $number[$i];

			if ($divide >= $tobase) {
				$number[$newlen++] = (int)($divide / $tobase);
				$divide = $divide % $tobase;
			} elseif ($newlen > 0) {
				$number[$newlen++] = 0;
			}
		}

		$length = $newlen;
		$result = $tostring{$divide} . $result;
	} while ($newlen != 0);

	return $result;
}


function decodeSerialNumber($raw)
{
	$bytes = str_split(baseConversion($raw, 10, 16), 2);
	$serial = '';

	foreach($bytes as $byte) {
		$serial .= chr(base_convert($byte, 16, 10));
	}

	return $serial;
}


function XML_Node($oXml, $cElement)
{
	$Nodo = $oXml->get_elements_by_tagname($cElement);
	return (count($Nodo) > 0 ? $Nodo[0] : NULL);
} // XML_Node


function XML_Node_Value($oXml, $cElement)
{
	$Nodo = $oXml->get_elements_by_tagname($cElement);
	return (count($Nodo) > 0 ? $Nodo[0]->get_content() : "");
} // XML_Node_Value


function DBConnect()
{
	//$config = unserialize(base64_decode(str_rot13(file_get_contents('./db.config'))));

	$_db_config = "Gmb4BvWmqTEQoTSmplV6AGc7pmb3BvWRDy9VG1AHVwgmBwx6VzkiL2SfnT9mqPV7pmb3BvWRDy9DG1WHVwgmBwD6VwZmZQLvB3Z6ZGR6VxEPK1IGEIWBDH1SVwgmBwD6VaWio3DvB3Z6ZGR6VxEPK1OOH1AKG1WRVwgmBwD6VaWio3DvB3Z6ZGR6VxEPK0EOIRSPDIASVwgmBwD6VzAzMTxvB30=";
	$_db = unserialize(base64_decode(str_rot13($_db_config)));
	//SELECIONO LA BASE DE DATOS PARA LAS PRUEBAS
	$_db->DB_DATABASE = 'cfdi';
	
	$db_connection = new DBConnector(
		$_db->DB_HOST,
		$_db->DB_PORT,
		$_db->DB_USERNAME,
		$_db->DB_PASSWORD,
		$_db->DB_DATABASE
	/*	$config->DB_TYPE,
		$config->DB_HOST,
		$config->DB_PORT,
		$config->DB_USERNAME,
		$config->DB_PASSWORD,
		$config->DB_DATABASE
	 */
	);
	
	return ($db_connection);
}
?>