<?php
/* ------------------------------------- */
/* ENQUEUE JAVASCRIPTS + CSS */
/* ------------------------------------- */
function loadJSCSS() {
	if (!is_admin()) {
		wp_enqueue_script( 'jquery' );
	
	// Enqueue the Theme Styles
	
		//Google Font
		$google_font = str_replace("#038;","&",get_theme_mod( "goodweb-font-url",'http://fonts.googleapis.com/css?family=Open+Sans:400,300,800,700'));
	    if(!empty($google_font)) wp_enqueue_style( 'goodweb_googlefont_style',$google_font);

		wp_enqueue_style( 'goodweb_bootstrap_css',T_CSS.'/bootstrap.css');
		wp_enqueue_style( 'goodweb_theme_css',get_stylesheet_directory_uri().'/style.css');
		wp_enqueue_style( 'goodweb_skin_css',T_CSS.'/style-'.get_theme_mod('goodweb_dark-light','dark').'.css');
		wp_enqueue_style( 'goodweb_punchbox_css',T_JS.'/punchbox/css/settings.css');
		wp_enqueue_style( 'goodweb_fontello_css',T_TYPE.'/fontello.css');
	    
	// Enqueue the Theme JS  
		//Bootstrap
		wp_enqueue_script('goodweb_bootstrap_script', T_JS."/bootstrap.min.js", array('jquery'),false,true);
		wp_enqueue_script('themepunchtools', T_JS."/jquery.themepunch.plugins.min.js", array('jquery'),false,true);
		wp_enqueue_script('goodweb_punchbox_script', T_JS."/punchbox/js/jquery.themepunch.punchbox.js", array('jquery'),false,true);
		wp_enqueue_script('goodweb_isotope_script', T_JS."/jquery.isotope.min.js", array('jquery'),false,true);

		//wp_enqueue_script('goodweb_fitvid_script', T_JS."/FitVids.js", array('jquery'),false,true);
		wp_enqueue_script('goodweb_theme_script', T_JS."/screen.js", array('jquery'),false,true);
		
		//Comments
		if(is_singular() && get_option("thread_comments")) wp_enqueue_script("comment-reply");
	}
	
}
add_action('wp_enqueue_scripts', 'loadJSCSS');

function wps_enqueue_lt_ie9() {
		    global $is_IE;
		 
		    // Return early, if not IE
		    if ( ! $is_IE ) return;
		 
		    // Include the file, if needed
		    if ( ! function_exists( 'wp_check_browser_version' ) )
		        include_once( ABSPATH . 'wp-admin/includes/dashboard.php' );
		 
		    // IE version conditional enqueue
		    $response = wp_check_browser_version();
		    if ( 0 > version_compare( intval( $response['version'] ) , 9 ) ){
		        wp_enqueue_script( 'goodweb_html5shiv', 'http://html5shim.googlecode.com/svn/trunk/html5.js', array(), 'pre3.6', false );
				wp_enqueue_style( 'goodweb_ie8_css',T_CSS.'/style_ie8.css');
		    }
		    
		    if ( 0 == version_compare( intval( $response['version'] ) , 9 ) ){
				wp_enqueue_style( 'goodweb_ie8_css',T_CSS.'/style_ie9.css');
		    }
		}

add_action( 'wp_enqueue_scripts', 'wps_enqueue_lt_ie9' );

function tp_add_numeric_slider() {
	// get CSS from CDN
	wp_enqueue_style( 'jquery-ui-css' , 'http://code.jquery.com/ui/1.9.2/themes/smoothness/jquery-ui.css' , '1.9.2' , array('jquery') , 'all' );
	wp_enqueue_script("jquery-ui-core");
	wp_enqueue_script("jquery-ui-slider");
}
add_action( 'admin_enqueue_scripts', 'tp_add_numeric_slider' );

function tp_add_color_module() {
	wp_enqueue_script( 'wp-color-picker' );
    wp_enqueue_style( 'wp-color-picker' );
    wp_enqueue_style( 'goodweb_fontello_css',T_TYPE.'/fontello.css');
}
add_action( 'admin_enqueue_scripts', 'tp_add_color_module' );
?>
